<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	
	<!-- bootstrap css -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

	<!-- Custom CSS -->
	<link rel="stylesheet" href="index.css">

	<title>Bootstrap Flex</title>
</head>
<body>
	<h1 class="text-center mt-5">Boostrap Flex</h1>
	<!-- 
		Flexbox

		Flexbox is used to manipulate and layout our elements. This can also be done exclusively in CSS. However, with bootstrap, we can apply flex faster and easier becuase we only need to add d-flex as a class for our parent container to make its children as flex items.

		Flex items/children are not exactly elements in that we can maniopulate its height and width

		Flex-direction

		Flex items are, by default, arranged in row

		The default direction of flex items is flex-row.

		You can change the direction of your flex items as flex-row, flex-row-reverse, flex-column, flex-column-reverse

		flex-row start from left to right (default)

		Flex Row Reverse
			- starts our items from the opposite side and this reverses the order of our items

		flex-row-reverse starts from right to left

		Flex column
		flex column will arrange our item from top to bottom in a column

		Flex Column Reverse
		flex-column-reverse will reverse the start of our flex column item that it will now start from the bottom
	 -->

	 <h3 class="text-center my-3">Flex Row</h3>
	 <div class="bg-dark d-flex mb-4">
	 	<div class="bg-primary p-2">Flex item 1</div>
	 	<div class="bg-danger p-2">Flex item 2</div>
	 	<div class="bg-success p-2">Flex item 3</div>
	 </div>

	 <h3 class="text-center my-3">Flex Row Reverse</h3>
	 <div class="bg-dark d-flex flex-row-reverse mb-4">
	 	<div class="bg-primary p-2">Flex item 1</div>
	 	<div class="bg-danger p-2">Flex item 2</div>
	 	<div class="bg-success p-2">Flex item 3</div>
	 </div>

	 <h3 class="text-center my-3">Flex Column</h3>
	 <div class="bg-dark d-flex flex-column mb-4">
	 	<div class="bg-primary p-2">Flex item 1</div>
	 	<div class="bg-danger p-2">Flex item 2</div>
	 	<div class="bg-success p-2">Flex item 3</div>
	 </div>

	 <h3 class="text-center my-3">Flex Column Reverse</h3>
	 <div class="bg-dark d-flex flex-column-reverse mb-4">
	 	<div class="bg-primary p-2">Flex item 1</div>
	 	<div class="bg-danger p-2">Flex item 2</div>
	 	<div class="bg-success p-2">Flex item 3</div>
	 </div>

	 <h3 class="text-center my-3">Flex Column Reverse using CSS</h3>
	  <div class="container">
	  	<div class="item">Flex item 1</div>
	 	<div class="item">Flex item 2</div>
	 	<div class="item">Flex item 3</div>
	 </div>

	 <h3 class="text-center my-3">Span as Flex Column Items</h3>
	 <div class="bg-dark d-flex flex-column mb-4">
	 	<div class="bg-primary p-2">Span Flex item 1</div>
	 	<div class="bg-danger p-2">Span Flex item 2</div>
	 	<div class="bg-success p-2">Span Flex item 3</div>
	 </div>

	 <!--Justify Content 
		justify-content will allow us to manipulate and change the horizontal alignment of flex row items. However, for flex column items, justify-content manipulate the vertical alignment.
	 -->
	 <h2 class="text-center my-5">Justify Content</h2>
	 <h3 class="text-center my-5">Justify Content Start</h3>
	 <!-- justify-content-start is the default value of justify-content for flex items, it allows us to align our items at the start of the flex items. For flex row, the start is from left, for flex row reverse it is from the right-->
	 <div class="bg-dark d-flex flex-row justify-content-start mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Justify Content End</h3>
	 <!-- justify-content-end it allows us to align our flex items to where its horizotnal alignments end,
	 	For flex-row, the end is from the right. For flex-row-reverse,the end is from the left -->
	 <div class="bg-dark d-flex flex-row justify-content-end mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	<div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Justify Content Center</h3>
	 <!-- Allows us to center our flex row items horizontally -->
	 <div class="bg-dark d-flex flex-row justify-content-center mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Justify Content Between</h3>
	 <!-- justify-content-between add/distributes the remaining spaces in between you flex items -->
	 <div class="bg-dark d-flex flex-row justify-content-between mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Justify Content Around</h3>
	 <!-- align our items by distributing space around our items. It will automatically calculate the remaining and distribute that spaces evenly around our flex items  -->
	 <div class="bg-dark d-flex flex-row justify-content-around mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>


	 <!-- Align Items -->
	 <h2>Align Items</h2>
	 <!-- Allows us to manipulate or layout our items vertically for flex-row and flex-row-reverse. Allow us to manipulate or layout our item horizontally flex-column and flex-column-reverse-->
	 <h3 class="text-center my-5">Align Items Start</h3>
	 <!-- allows us to align items at the start of the vertical alignment. Which is from the top for flex-row and flex-row-reverse items. For flex-column and flex-column-reverse, this will align items at the start of their horizontal alignment -->
	 <div class="bg-dark d-flex flex-row align-items-start mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse align-items-start mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Align Items End</h3>
	 <!-- align-items-end will align our flex-row and flex-row reverse items at the end of the vertival alignment, which is the bottom. For flex-column and flex-column-reverse, it will align at the end of their horizontal alignment -->
	 <div class="bg-dark d-flex flex-row align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-column align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-column-reverse align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Align Items Center</h3>
	 <div class="bg-dark d-flex flex-row align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <div class="bg-dark d-flex flex-row-reverse align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	 <h3 class="text-center my-5">Align Items Vertically and Horizontally</h3>
	 <div class="bg-dark d-flex flex-row justify-content-end align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>

	<div class="bg-dark d-flex flex-row justify-content-end align-items-end mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>	 

	 <div class="bg-dark d-flex flex-row justify-content-between align-items-center mb-4" style="height: 50vh">
	 	<div class="bg-warning p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-info p-2">Flex Item 3</div>
	 </div>


     <h3 class="text-center my-5"> Mini-Activity</h3>
     
     <div class="bg-dark d-flex justify-content-center flex-column align-items-center mb-4" style="height: 50vh">
        <div class="bg-warning p-2">Flex Item 1</div>
        <div class="bg-danger p-2">Flex Item 2</div>
        <div class="bg-info p-2">Flex Item 3</div>
    </div>
    
    <div class="bg-dark d-flex flex-row justify-content-around align-items-center mb-4" style="height: 50vh">
       <div class="bg-warning p-2">Flex Item 1</div>
       <div class="bg-danger p-2">Flex Item 2</div>
       <div class="bg-info p-2">Flex Item 3</div>
   </div>


<h2 class="text-center my-5">Flex Column with Align Items and Justify </h2>

<div class="bg-dark d-flex flex-column justify-content-center mb-4" style="height:50vh">
    <div class="bg-warning p-2" style="width: 20%;">Flex Item 1</div>
    <div class="bg-danger p-2" style="width: 20%;">Flex Item 1</div>
    <div class="bg-info p-2" style="width: 20%;">Flex Item 1</div>
</div>

<div class="bg-dark d-flex flex-column justify-content-end mb-4" style="height:50vh">
    <div class="bg-warning p-2" style="width: 20%;">Flex Item 1</div>
    <div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
    <div class="bg-info p-2" style="width: 20%;">Flex Item 3</div>
</div>


<div class="bg-dark d-flex flex-column align-items-end mb-4" style="height: 50vh">
    <div class="bg-warning p-2" style="width: 20%;">Flex Item 1</div>
    <div class="bg-danger p-2" style="width: 20%;">Flex Item 2</div>
    <div class="bg-info p-2" style="width: 20%;">Flex Item 3</div>
</div>

<h2 class="text-center my-5">Flex-wrap</h2>
<div class="bg-dark d-flex flex-row flex-wrap mb-4">

    <div class="bg-primary p-2">Flex Item 1</div>
    <div class="bg-danger p-2">Flex Item 2</div>
    <div class="bg-success p-2">Flex Item 3</div>
    <div class="bg-warning p-2">Flex Item 1</div>
    <div class="bg-info p-2">Flex Item 2</div>
    <div class="bg-primary p-2">Flex Item 3</div>
    <div class="bg-success p-2">Flex Item 1</div>
    <div class="bg-danger p-2">Flex Item 2</div>
    <div class="bg-warning p-2">Flex Item 3</div>

</div>


    <!-- Mini-Activity
			Add an h3 with the text Mini-Activity with Flex Row
				- Center the text
				- Add a bootstrap size 5 margin at the top and bottom of the h3

			Add a div as a flex parent:
				Add classes to arrange/align our items:
					- Arrange items in a row
					- Center the items horizontally and vertically
					- You can copy the div items from our other examples
					- Add dark bg to the flex parent
					- Make sure the flex parent has 50vh in height
			
			Add a div as a flex parent:
				Add classes to arrange/align our items:
					- Arrange items in a row
					- Center the items vertically
					- Align items horizontally by evenly distributing space around the items
					- You can copy the div flex items from our other examples
					- Add dark bg to the flex parent
					- Make sure the flex parent has 50vh in height
	-->


	<!-- bootstrap js  -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>
